#ifndef _H_D2F4D414F2FDEB5E3A3B8289D6BE7A5D_Extrinsics_DCPS_H_
#define _H_D2F4D414F2FDEB5E3A3B8289D6BE7A5D_Extrinsics_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Extrinsics_.h"


namespace realsense_camera_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Extrinsics_TypeSupportInterface;

            typedef Extrinsics_TypeSupportInterface * Extrinsics_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Extrinsics_TypeSupportInterface> Extrinsics_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Extrinsics_TypeSupportInterface> Extrinsics_TypeSupportInterface_out;


            class Extrinsics_DataWriter;

            typedef Extrinsics_DataWriter * Extrinsics_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Extrinsics_DataWriter> Extrinsics_DataWriter_var;
            typedef DDS_DCPSInterface_out < Extrinsics_DataWriter> Extrinsics_DataWriter_out;


            class Extrinsics_DataReader;

            typedef Extrinsics_DataReader * Extrinsics_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Extrinsics_DataReader> Extrinsics_DataReader_var;
            typedef DDS_DCPSInterface_out < Extrinsics_DataReader> Extrinsics_DataReader_out;


            class Extrinsics_DataReaderView;

            typedef Extrinsics_DataReaderView * Extrinsics_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Extrinsics_DataReaderView> Extrinsics_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Extrinsics_DataReaderView> Extrinsics_DataReaderView_out;

            struct Extrinsics_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Extrinsics_, struct Extrinsics_Seq_uniq_> Extrinsics_Seq;
            typedef DDS_DCPSSequence_var < Extrinsics_Seq> Extrinsics_Seq_var;
            typedef DDS_DCPSSequence_out < Extrinsics_Seq> Extrinsics_Seq_out;

            class  Extrinsics_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Extrinsics_TypeSupportInterface_ptr _ptr_type;
                typedef Extrinsics_TypeSupportInterface_var _var_type;

                static Extrinsics_TypeSupportInterface_ptr _duplicate (Extrinsics_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Extrinsics_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Extrinsics_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Extrinsics_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Extrinsics_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Extrinsics_TypeSupportInterface () {};
                ~Extrinsics_TypeSupportInterface () {};
            private:
                Extrinsics_TypeSupportInterface (const Extrinsics_TypeSupportInterface &);
                Extrinsics_TypeSupportInterface & operator = (const Extrinsics_TypeSupportInterface &);
            };

            class  Extrinsics_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Extrinsics_DataWriter_ptr _ptr_type;
                typedef Extrinsics_DataWriter_var _var_type;

                static Extrinsics_DataWriter_ptr _duplicate (Extrinsics_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Extrinsics_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Extrinsics_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Extrinsics_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Extrinsics_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Extrinsics_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Extrinsics_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Extrinsics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Extrinsics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Extrinsics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Extrinsics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Extrinsics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Extrinsics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Extrinsics_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Extrinsics_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Extrinsics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Extrinsics_& instance_data) = 0;

            protected:
                Extrinsics_DataWriter () {};
                ~Extrinsics_DataWriter () {};
            private:
                Extrinsics_DataWriter (const Extrinsics_DataWriter &);
                Extrinsics_DataWriter & operator = (const Extrinsics_DataWriter &);
            };

            class  Extrinsics_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Extrinsics_DataReader_ptr _ptr_type;
                typedef Extrinsics_DataReader_var _var_type;

                static Extrinsics_DataReader_ptr _duplicate (Extrinsics_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Extrinsics_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Extrinsics_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Extrinsics_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Extrinsics_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Extrinsics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Extrinsics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Extrinsics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Extrinsics_& instance) = 0;

            protected:
                Extrinsics_DataReader () {};
                ~Extrinsics_DataReader () {};
            private:
                Extrinsics_DataReader (const Extrinsics_DataReader &);
                Extrinsics_DataReader & operator = (const Extrinsics_DataReader &);
            };

            class  Extrinsics_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Extrinsics_DataReaderView_ptr _ptr_type;
                typedef Extrinsics_DataReaderView_var _var_type;

                static Extrinsics_DataReaderView_ptr _duplicate (Extrinsics_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Extrinsics_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Extrinsics_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Extrinsics_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Extrinsics_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Extrinsics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Extrinsics_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Extrinsics_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Extrinsics_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Extrinsics_& instance) = 0;

            protected:
                Extrinsics_DataReaderView () {};
                ~Extrinsics_DataReaderView () {};
            private:
                Extrinsics_DataReaderView (const Extrinsics_DataReaderView &);
                Extrinsics_DataReaderView & operator = (const Extrinsics_DataReaderView &);
            };
        }

    }

}

#endif
